(* Title:  Knowledge/biegelinie-2.sml
   author: Walther Neuper 190515
   (c) due to copyright terms
*)
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- auto SubProblem (_,[vonBelastungZu,Biegelinien] -----";
"----------- me SubProblem (_,[vonBelastungZu,Biegelinien] -------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";


"----------- auto SubProblem (_,[vonBelastungZu,Biegelinien] -----";
"----------- auto SubProblem (_,[vonBelastungZu,Biegelinien] -----";
"----------- auto SubProblem (_,[vonBelastungZu,Biegelinien] -----";
val fmz = 
    ["Streckenlast q_0", "FunktionsVariable x",
     "Funktionen [Q x = c + -1 * q_0 * x, \
     \M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2,\
     \ y' x = c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3),\
     \ y x = c_4 + c_3 * x + 1 / (-1 * EI) * (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]",
    "AbleitungBiegelinie dy"];
val (dI',pI',mI') = ("Biegelinie", ["vonBelastungZu", "Biegelinien"],
		     ["Biegelinien", "ausBelastung"]);

reset_states ();
CalcTree [(fmz, (dI',pI',mI'))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;

val ((pt, p),_) = get_calc 1;
if p = ([], Res) andalso (get_obj g_res pt (fst p) |> UnparseC.term) =
   "[Q x = c + -1 * q_0 * x, M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2,\n dy x =\n c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3),\n y x =\n c_4 + c_3 * x +\n 1 / (-1 * EI) *\n (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]"
then () else error "auto SubProblem (_,[vonBelastungZu,Biegelinien] changed";


"----------- me SubProblem (_,[vonBelastungZu,Biegelinien] -------";
"----------- me SubProblem (_,[vonBelastungZu,Biegelinien] -------";
"----------- me SubProblem (_,[vonBelastungZu,Biegelinien] -------";
val fmz = 
    ["Streckenlast q_0", "FunktionsVariable x",
     "Funktionen [Q x = c + -1 * q_0 * x, \
     \M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2,\
     \ y' x = c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3),\
     \ y x = c_4 + c_3 * x + 1 / (-1 * EI) * (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]",
    "AbleitungBiegelinie dy"];
val (dI',pI',mI') = ("Biegelinie", ["vonBelastungZu", "Biegelinien"],
		     ["Biegelinien", "ausBelastung"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of ("Apply_Method", Apply_Method ["Biegelinien", "ausBelastung"]) => ()
| _ => error "biegelinie.sml met2 b";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =   "q_ x = q_0";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "- q_ x = - q_0";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =  "Q' x = - q_0";
case nxt of (_, Subproblem (_, ["named", "integrate", "function"])) => ()
| _ => error "biegelinie.sml met2 c";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "Q x = c + -1 * q_0 * x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "Q x = c + -1 * q_0 * x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "M_b' x = c + -1 * q_0 * x";
case nxt of (_,Subproblem (_, ["named", "integrate", "function"])) => ()
| _ => error "biegelinie.sml met2 d";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
		   "M_b x = Integral c + -1 * q_0 * x D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
		   "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
		   "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
		   "- EI * y'' x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
		   "y'' x = 1 / - EI * (c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2)";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
    "y' x = Integral 1 / - EI * (c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2) D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y' x = Integral 1 / (-1 * EI) * (c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2) D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y' x =\nc_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y' x =\nc_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y x =\nIntegral c_3 +\n         1 / (-1 * EI) *\n         (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3) D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y x =\nc_4 + c_3 * x +\n1 / (-1 * EI) *\n(c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
   "y x =\nc_4 + c_3 * x +\n1 / (-1 * EI) *\n(c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
if f2str f =
   "[Q x = c + -1 * q_0 * x, M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2,\n dy x =\n c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3),\n y x =\n c_4 + c_3 * x +\n 1 / (-1 * EI) *\n (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]"
then case nxt of ("End_Proof'", End_Proof') => ()
  | _ => error "biegelinie.sml met2 e 1"
else error "biegelinie.sml met2 e 2";


