(* tests on simplification
   author: Walther Neuper
   061019
   (c) due to copyright terms

use"../smltest/IsacKnowledge/simplify.sml";
use"simplify.sml";
*)

"--------------------------------------------------------";
"--------------------------------------------------------";
"table of contents --------------------------------------";
"--------------------------------------------------------";
"----------- CAS-command Simplify -----------------------";
"----------- append inform with final result ------------";
"--------------------------------------------------------";
"--------------------------------------------------------";
"--------------------------------------------------------";

val thy = @{theory "Simplify"};

"----------- CAS-command Simplify -----------------------";
"----------- CAS-command Simplify -----------------------";
"----------- CAS-command Simplify -----------------------";
reset_states ();
CalcTree [([], ("empty_thy_id", ["empty_probl_id"], ["empty_meth_id"]))];
Iterator 1;
moveActiveRoot 1;
replaceFormula 1 "Simplify (2*a + 3*a)";
autoCalculate 1 (Steps 1);
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1;
val Form res = (#1 o ME_Misc.pt_extract) (pt, ([],Res)); Test_Tool.show_pt pt; UnparseC.term res;
if p = ([], Res) andalso UnparseC.term res = "5 * a" then ()
else error "simplify.sml: diff.behav. CAScmd: Simplify (2*a + 3*a)";

"----------- append inform with final result ------------";
"----------- append inform with final result ------------";
"----------- append inform with final result ------------";
reset_states ();
CalcTree [(["Term ((14 * x * y) / ( x * y ))", "normalform N"],
	("Rational", ["rational", "simplification"], ["simplification", "of_rationals"]))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalcHead;
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt; 
(*[
(([], Frm), Simplify (14 * x * y / (x * y)))] *)
ME_Misc.pt_extract (pt, p); (*determines SOME (Apply_Method ["simplification", "of_rationals"])*)

autoCalculate 1 (Steps 1);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
(*[
(([], Frm), Simplify (14 * x * y / (x * y))),
(([1], Frm), 14 * x * y / (x * y))] *)

appendFormula 1 "14" (*|> Future.join*);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
(*[
(([], Frm), Simplify (14 * x * y / (x * y))),
(([1], Frm), 14 * x * y / (x * y)),
(([1,1], Frm), 14 * x * y / (x * y)),
(([1,1], Res), 14 * (x * y) / (x * y)),
(([1,2], Res), 14 / 1),
(([1,3], Res), 14),
(([1], Res), 14)]*)

autoCalculate 1 (Steps 1);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
(*[
(([], Frm), Simplify (14 * x * y / (x * y))),
(([1], Frm), 14 * x * y / (x * y)),
(([1,1], Frm), 14 * x * y / (x * y)),
(([1,1], Res), 14 * (x * y) / (x * y)),
(([1,2], Res), 14 / 1),
(([1,3], Res), 14),
(([1], Res), 14),
(([], Res), 14)] *)
val Form res = (#1 o ME_Misc.pt_extract) (pt, ([],Res));
if p = ([], Res) andalso UnparseC.term res = "14" then ()
else error "simplify.sml: append inform with final result changed";

