(* Title:  "Specify/step-specify.sml"
   Author: Walther Neuper
   (c) due to copyright terms
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- re-build: Step_Specify.do_next  ---------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";

open Step_Specify;
"----------- re-build: Step_Specify.do_next  ---------------------------------------------------";
"----------- re-build: Step_Specify.do_next  ---------------------------------------------------";
"----------- re-build: Step_Specify.do_next  ---------------------------------------------------";
reset_states ();  
CalcTree (*ATTENTION: encode_fmz ... unlike CalcTreeTEST*)
    [(["functionTerm (x^2 + 1)", "integrateBy x", "antiDerivative FF"],
      ("Integrate", ["integrate", "function"], ["diff", "integration"]))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 (Steps 1); 

val (ptp as (pt, p), _) = get_calc 1;
pt;(*isa==REP*)
val (_, ("Integrate", ["integrate", "function"], ["diff", "integration"]), _)
  = get_obj g_origin pt (fst p);
get_obj g_spec pt (fst p) = ("empty_thy_id", ["empty_probl_id"], ["empty_meth_id"]); (*isa==REP*)

(*this steps into according to "----- step 2 ---" below*)
"~~~~~ fun autoCalculate , args:"; val (cI, auto) = (1, (Steps 1));
     val pold = get_pos cI 1
;
    (*case*) Math_Engine.autocalc [] pold (get_calc cI) auto (*of*);
"~~~~~ fun autocalc , args:"; val (c: pos' list, ip, cs, (Solve.Steps s)) = ([], pold, (get_calc cI), auto);
val c''''' = c; (*for from fun nxt_specify_\<longrightarrow>fun Step.do_next\<longrightarrow>fun autocalc, return*)

    (*if*) s <= 1 (*then*);
    (**)val ("ok", (([(Specify_Theory "Integrate", _, _)]), c', ptp)) =(**)
Step.do_next ip cs;
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt,p), tacis)) = (ip, cs);
    val pIopt = Ctree.get_pblID (pt, ip);
    (*if*) ip = ([], Pos.Res) (*else*);
   val [] = (*case*) tacis (*of*);
    val SOME _ = (*case*) pIopt (*of*);
    (*if*) member op = [Pos.Pbl, Pos.Met] p_  (*then*);

  val ("ok", ([(Specify_Theory "Integrate", _, _)], _, _)) =
      Step.specify_do_next (pt, ip);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = (pt, ip);
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
    val _ = (*case*) tac (*of*);
      ("ok", Step_Specify.by_tactic_input tac (pt, (p, p_'))) (*return from specify_do_next*);

"~~~~~ from fun nxt_specify_\<longrightarrow>fun Step.do_next\<longrightarrow>fun autocalc, return:"; val (str, (_, c', ptp))
  = Step_Specify.by_tactic_input tac ptp;

        (str, c''''' @ c', ptp) (*return from autocalc*);

"----- step 2 ---";(*isa<>REP*)
autoCalculate 1 (Steps 1);

val (ptp as (pt, p), _) = get_calc 1;
pt;(*REP
val it =
   Nd (PblObj
:
         result = (Const ("empty", "??.'a"), []), spec =
         ("Integrate", ["integrate", "function"], ["empty_meth_id"])},
       []):
   ctree*)

"----- step 3 ---";
autoCalculate 1 (Steps 1);
val (ptp as (pt, p), _) = get_calc 1;

"----- step 4 ---";
autoCalculate 1 (Steps 1);
"----- step 5 ---";
autoCalculate 1 (Steps 1);
"----- step 6 ---";
autoCalculate 1 (Steps 1);
"----- step 7 ---";
autoCalculate 1 (Steps 1);
"----- step 8 ---";
autoCalculate 1 (Steps 1);

val (ptp as (_, p), _) = get_calc 1;

val (Form t,_,_) = ME_Misc.pt_extract ptp;

if UnparseC.term t = "c + x + 1 / 3 * x ^^^ 3" andalso p = ([], Res) then ()
else error "mathengine.sml -- fun autoCalculate -- end";
