theory Thy_3 imports Thy_2 Thy_2b begin

ML \<open>val test_list_rls =
  Rule_Set.append_rules "test_list_rls" Rule_Set.empty [Rule.Thm ("not_def", @{thm not_def})]\<close>

setup \<open>Test_KEStore_Elems.add_rlss (*already added in Thy_1.thy and Thy_2.thy*)
  [("test_list_rls", (Context.theory_name @{theory}, test_list_rls))]\<close>

ML \<open>
  if length (Test_KEStore_Elems.get_rlss @{theory}) = 1 (*stored in 3 different theories*)
  then () else error "rls identified by string-identifier, not by theory: changed"

(*test_ruleset' := overwritelthy @{theory} (! test_ruleset', [("test_list_rls", 
    Rule_Set.append_rules "test_list_rls" test_list_rls [Eval ("test_function", e_evalfn)])])*)
  ;
(*if length (Test_KEStore_Elems.get_rlss @{theory}) = length (! test_ruleset')
  then () else error "Test_KEStore_Elems.get_rlss = test_ruleset': changed"*)
  ;
  val SOME (_, Rule_Set.Repeat {rules, ...}) =
    AList.lookup op= (Test_KEStore_Elems.get_rlss @{theory}) "test_list_rls"
  ;
  case rules of
    [Rule.Thm ("not_def", _)] => ()
  | _ => error "union rls_eq changed: 1st argument is NOT overwritten anymore"
  (* merge rules of rls with the same Rule_Set.id must be done one level higher:
    Test_KEStore_Elems.add_rlss does *add* or *overwrite* *)
\<close>

end
