(* Title:  BridgeLibisabelle/thy-present.sml
   Author: Walther Neuper
   (c) due to copyright terms
*)

"--------------------------------------------------------";
"--------------------------------------------------------";
"table of contents --------------------------------------";
"--------------------------------------------------------";
"----------- fun thy_containing_rls ---------------------";
"----------- apply thy_containing_rls -------------------";
"----------- fun thy_containing_cal ---------------------";
"----------- initContext Ptool.Thy_ Integration-demo ----------";
"----------- initContext..Ptool.Thy_, fun context_thm ---------";
"----------- initContext..Ptool.Thy_, fun context_rls ---------";
"----------- checkContext..Ptool.Thy_, fun context_thy --------";
"----------- checkContext..Ptool.Thy_, fun context_rls --------";
"----------- checkContext..Ptool.Thy_ on last formula ---------"; 
"----------- fun guh2theID ------------------------------";
"----------- debugging on Tests/solve_linear_as_rootpbl -";
"--------------------------------------------------------";
(*============ inhibit exn WN120321 ==============================================
"--------------------------------------------------------";
"----------- fun filter_appl_rews -----------------------";
============ inhibit exn WN120321 ==============================================*)
"----------- fun is_contained_in ------------------------";
"--------------------------------------------------------";
"--------------------------------------------------------";

"----------- fun thy_containing_rls ---------------------";
"----------- fun thy_containing_rls ---------------------";
"----------- fun thy_containing_rls ---------------------";
(*ERROR WAS: Theory loader: undefined entry for theory "Isac.Complex_Main"*)
if Thy_Read.thy_containing_rls "Biegelinie" "norm_Poly" = ("IsacKnowledge", "Poly") then ()
else error ("thy_containing_rls changed for 'Biegelinie', 'norm_Poly'")  
;
"~~~~~ fun thy_containing_rls, args:"; val (thy', rls') = ("Biegelinie", "norm_Poly");
    val thy = ThyC.get_theory thy'; (*.., EqSystem, Isac.Biegelinie}*)
val xxx = AList.lookup op= (KEStore_Elems.get_rlss thy) rls';
val SOME (thy'', _) = xxx;
val SOME ("Poly", _) = xxx;
if thy'' = "Poly" then () else error "--- fun thy_containing_rls: changed";
(*ERROR WAS: Theory loader: undefined entry for theory "Isac.Complex_Main" *)
if Thy_Read.partID' thy'' = "IsacKnowledge" then () else error "fun partID': changed"
;
"~~~~~ fun partID', args:"; val (thy') = (thy');
ThyC.get_theory thy' (*.., EqSystem, Isac.Biegelinie}*)
;
"~~~~~ fun partID, args:"; val (thy) = (ThyC.get_theory thy');
(*ERROR WAS: Theory loader: undefined entry for theory "Isac.Complex_Main"*)
Thy_Read.knowthys () 
;
"~~~~~ fun knowthys , args:"; val () = ();
        val allthys = filter_out (member Context.eq_thy
          [(*ThyC.get_theory "ProgLang",*) ThyC.get_theory "Interpret", 
            ThyC.get_theory "MathEngine", ThyC.get_theory "BridgeLibisabelle"]) 
          (Theory.ancestors_of (ThyC.get_theory "Build_Thydata"));
length allthys = 152; (*in Isabelle2015/Isac*)
(*ERROR WAS: Theory loader: undefined entry for theory "Isac.Complex_Main"
ThyC.get_theory "Complex_Main";*)
Thy_Info.get_theory "Complex_Main";;

"----------- apply thy_containing_rls -------------------";
"----------- apply thy_containing_rls -------------------";
"----------- apply thy_containing_rls -------------------";
if Thy_Read.thy_containing_rls "Biegelinie" "norm_Poly" = ("IsacKnowledge", "Poly") then ()
else error ("Thy_Read.thy_containing_rls changed for 'Biegelinie', 'norm_Poly'")
;
if Thy_Read.thy_containing_rls "Biegelinie" "empty" = ("IsacScripts", "Know_Store") then ()
else error ("Thy_Read.thy_containing_rls changed for 'Biegelinie', 'e_rls'")
;
if Thy_Read.thy_containing_rls "Build_Thydata" "prog_expr" = (*FIXME: handle redifinition in several thys*)
(**)("IsacKnowledge", "Base_Tools")(**)
(** )("IsacScripts", "Prog_Expr")( **)
then () else error ("Thy_Read.thy_containing_rls changed for 'Biegelinie', 'prog_expr'")

"----------- fun thy_containing_cal ---------------------";
"----------- fun thy_containing_cal ---------------------";
"----------- fun thy_containing_cal ---------------------";
(* ATTENTION: both, "IsacKnowledge" and "Prog_Expr" are fixed as results for any input*)
if Thy_Read.thy_containing_cal "Biegelinie" "PLUS" = ("IsacKnowledge", "Base_Tools")
then () else error "(wrong) thy_containing_cal 'Biegelinie' 'PLUS' changed"

"----------- initContext Ptool.Thy_ Integration-demo ----------";
"----------- initContext Ptool.Thy_ Integration-demo ----------";
"----------- initContext Ptool.Thy_ Integration-demo ----------";
reset_states ();
CalcTree
[(["functionTerm (2 * x)", "integrateBy x", "antiDerivative FF"], 
  ("Integrate",["integrate", "function"],
  ["diff", "integration"]))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
interSteps 1 ([1],Res);
interSteps 1 ([1,1],Res);
val ((pt,p),_) = get_calc 1; Test_Tool.show_pt pt;
if existpt' ([1,1,1], Frm) pt then ()
else error "integrate.sml: interSteps on Rewrite_Set_Inst 1";
Kernel.initContext  1 Ptool.Thy_ ([1,1,1], Frm);

"----------- initContext..Ptool.Thy_, fun context_thm ---------";
"----------- initContext..Ptool.Thy_, fun context_thm ---------";
"----------- initContext..Ptool.Thy_, fun context_thm ---------";
reset_states (); (*start of calculation, return No.1*)
CalcTree [(["equality (x+1=(2::real))", "solveFor x", "solutions L"], 
  ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]))];
Iterator 1; moveActiveRoot 1;
autoCalculate 1 CompleteCalc;

"----- no thy-context at result -----";
val p = ([], Res);
initContext 1 Ptool.Thy_ p;
val ((pt,_),_) = get_calc 1; Test_Tool.show_pt pt; (* 11 lines with subpbl *)

interSteps 1 ([2], Res);
val ((pt,_),_) = get_calc 1; Test_Tool.show_pt pt; (* added [2,1]..[2,6] *)
interSteps 1 ([3,1], Res);
val ((pt,_),_) = get_calc 1; Test_Tool.show_pt pt; (* added [3,1,1] Frm + Res *)

val p = ([2,4], Res);
"~~~~~ fun initContext, args:"; val ((cI:calcID), Ptool.Thy_, (pos as (p,p_):pos')) = (1, Ptool.Thy_, p);
  member op = [Pbl,Met] p_ = false;
  pos = ([],Res) = false;
  val cs as (ptp as (pt,_),_) = get_calc cI;
  exist_lev_on' pt pos = true;
              val pos' = lev_on' pt pos
              val tac = Thy_Present.get_tac_checked pt pos';
  is_rewtac tac = true;
"~~~~~ fun context_thy, args:"; val ((pt, pos as (p,p_)), (tac as Rewrite (thmID,_))) =
  ((pt, pos), tac);
    val Applicable.Yes (Rewrite' (thy', ord', erls, _, (thmID, thm), f, (res,asm))) = Step.check tac (pt, pos)
            val thm = Global_Theory.get_thm (Isac ()(*WN141021 ThyC.get_theory thy' ERROR*)) thmID
            val thm_deriv = Thm.get_name_hint thm;

if Thy_Write.thm2guh (Thy_Read.thy_containing_thm thm_deriv) (ThmC.cut_id thm_deriv)
   = "thy_isac_Test-thm-radd_left_commute" then ()
else error "context_thy mini-subpbl ([2,4], Res) changed";
(*~/proto3/kbase/thy$ ls -l thy_isac_Test-thm-radd_left_commute*
-rw-rw-r-- 1 wneuper wneuper 638 Aug  8 16:04 thy_isac_Test-thm-radd_left_commute.html*)


val p = ([3,1,1], Frm);
"~~~~~ fun initContext, args:"; val ((cI:calcID), Ptool.Thy_, (pos as (p,p_):pos')) = (1, Ptool.Thy_, p);
  member op = [Pbl,Met] p_ = false;
  pos = ([],Res) = false;
  val cs as (ptp as (pt,_),_) = get_calc cI;
  exist_lev_on' pt pos = true;
              val pos' = lev_on' pt pos
              val tac = Thy_Present.get_tac_checked pt pos';
  is_rewtac tac = true;
"~~~~~ fun context_thy, args:"; val ((pt, pos as (p,p_)), (tac as Rewrite_Inst (subs, (thmID,_))))=
  ((pt, pos), tac);
val Applicable.Yes (Rewrite_Inst' (thy', ord', erls, _, subst, (thmID,_), f, (res, asm))) = 
   Step.check tac (pt, pos)
             val thm = Global_Theory.get_thm (Isac ()(*WN141021 ThyC.get_theory thy' ERROR*)) thmID
             val thm_deriv = Thm.get_name_hint thm;
if Thy_Write.thm2guh (Thy_Read.thy_containing_thm thm_deriv) (ThmC.cut_id thm_deriv) =
  "thy_isac_Test-thm-risolate_bdv_add" then ()
else error "context_thy mini-subpbl ([3,1,1], Frm) changed";
(*~/proto3/kbase/thy$ ls -l thy_isac_Test-thm-risolate_bdv_add*
-rw-rw-r-- 1 wneuper wneuper 646 Aug  8 16:04 thy_isac_Test-thm-risolate_bdv_add.html*)


val p = ([2,5], Res);
"~~~~~ fun initContext, args:"; val ((cI:calcID), Ptool.Thy_, (pos as (p,p_):pos')) = (1, Ptool.Thy_, p);
  member op = [Pbl,Met] p_ = false;
  pos = ([],Res) = false;
  val cs as (ptp as (pt,_),_) = get_calc cI;
 exist_lev_on' pt pos = true;
              val pos' = lev_on' pt pos
              val tac = Thy_Present.get_tac_checked pt pos';
if is_rewtac tac = false then () 
else error "initContext: context_thy .. Calculate PLUS .. TO BE IMPLEMENTED"

"----------- initContext..Ptool.Thy_, fun context_rls ---------";
"----------- initContext..Ptool.Thy_, fun context_rls ---------";
"----------- initContext..Ptool.Thy_, fun context_rls ---------";
(*using pt from above*)
val p = ([1], Res);
val tac = Rewrite_Set "Test_simplify";
initContext 1 Ptool.Thy_ p;
(*Res->Res, Rewrite_Set "Test_simplify" x + 1 + -1 * 2 = 0 -> -1 + x = 0
  --- in initContext..Ptool.Thy_ ---*)
val Thy_Present.ContRls {rls,result,...} = Thy_Present.context_thy (pt,p) tac;
if rls = "thy_isac_Test-rls-Test_simplify" 
   andalso UnparseC.term result = "-1 + x = 0" then ()
else error "rewtools.sml initContext..Th_ thy_isac_Test-rls-Test_simplify";

val p = ([3,1], Frm);
val tac = Rewrite_Set_Inst (["(''bdv'', x)"],"isolate_bdv");
initContext 1 Ptool.Thy_ p;
(*Frm->Res, Rewrite_Set_Inst "isolate_bdv" -1 + x = 0 ->  x = 0 + -1 * -1
  --- in initContext..Ptool.Thy_ ---*)
val Thy_Present.ContRlsInst {rls,result,...} = Thy_Present.context_thy (pt,p) tac;
if rls =  "thy_isac_Test-rls-isolate_bdv"
   andalso UnparseC.term result = "x = 0 + -1 * -1" then ()
else error "rewtools.sml initContext..Th_ thy_Test-thm-risolate_bdv_add";

"----------- checkContext..Ptool.Thy_, fun context_thy --------";
"----------- checkContext..Ptool.Thy_, fun context_thy --------";
"----------- checkContext..Ptool.Thy_, fun context_thy --------";
(*using pt from above*)
val p = ([2,4], Res);
val tac = Rewrite ("radd_left_commute", @{thm radd_left_commute});
checkContext 1 p "thy_Test-thm-radd_left_commute";
(* radd_left_commute: 1 + (-2 + x) = 0 -> -2 + (1 + x) = 0
  --- in checkContext..Ptool.Thy_ ---*)
val Thy_Present.ContThm {thm,result,...} = Thy_Present.context_thy (pt,p) tac;
if thm =  "thy_isac_Test-thm-radd_left_commute"
   andalso UnparseC.term result = "-2 + (1 + x) = 0" then ()
else error "rewtools.sml checkContext.._ thy_Test-thm-radd_left_commute";

val p = ([3,1,1], Frm);
val tac = Rewrite_Inst (["(''bdv'',x)"],("risolate_bdv_add", @{thm "risolate_bdv_add"}));
checkContext 1 p "thy_Test-thm-risolate_bdv_add";
(* risolate_bdv_add:  -1 + x = 0 -> x = 0 + -1 * -1
  --- in checkContext..Ptool.Thy_ ---*)
val Thy_Present.ContThmInst {thm,result,...} = Thy_Present.context_thy (pt,p) tac;
if thm =  "thy_isac_Test-thm-risolate_bdv_add"
   andalso UnparseC.term result = "x = 0 + - 1 * -1" then ()
else error "rewtools.sml checkContext..T_ thy_Test-thm-risolate_bdv_add";

val p = ([2,5], Res);
val tac = Calculate "plus";
(*checkContext..Ptool.Thy_ 1 ([2,5], Res);*)
(*FIXXXME #######################vvvvv kestoreID !!!!!!!!!!!!!!!!*)
checkContext 1 p ;
(* Calculate "plus"  -2 + (1 + x) = 0 -> -1 + x = 0
  --- in checkContext..Ptool.Thy_ ---*)

"----------- checkContext..Ptool.Thy_, fun context_rls --------";
"----------- checkContext..Ptool.Thy_, fun context_rls --------";
"----------- checkContext..Ptool.Thy_, fun context_rls --------";
(*using pt from above*)
val p = ([1], Res);
val tac = Rewrite_Set "Test_simplify";
checkContext 1 p "thy_isac_Test-rls-Test_simplify";
(*Res->Res, Rewrite_Set "Test_simplify" x + 1 + -1 * 2 = 0 -> -1 + x = 0
  --- in checkContext..Ptool.Thy_ ---*)
val Thy_Present.ContRls {rls,result,...} = Thy_Present.context_thy (pt,p) tac;
if rls = "thy_isac_Test-rls-Test_simplify" 
   andalso UnparseC.term result = "-1 + x = 0" then ()
else error "rewtools.sml checkContext..Ptool.Thy_ thy_Test-rls-Test_simplify";

val p = ([3,1], Frm);
val tac = Rewrite_Set_Inst (["(''bdv'', x)"],"isolate_bdv");
checkContext 1 p "thy_Test-rls-isolate_bdv";
val Thy_Present.ContRlsInst {rls,result,...} = Thy_Present.context_thy (pt,p) tac;
if rls = "thy_isac_Test-rls-isolate_bdv" 
   andalso UnparseC.term result = "x = 0 + -1 * -1" then ()
else error "rewtools.sml checkContext..Ptool.Thy_ thy_Test-thm-isolate_bdv";

"----------- checkContext..Ptool.Thy_ on last formula ---------"; 
"----------- checkContext..Ptool.Thy_ on last formula ---------"; 
"----------- checkContext..Ptool.Thy_ on last formula ---------"; 
reset_states (); (*start of calculation, return No.1*)
CalcTree [(["equality (x+1=(2::real))", "solveFor x", "solutions L"], 
  ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]))];
Iterator 1; moveActiveRoot 1;

autoCalculate 1 CompleteCalcHead;
autoCalculate 1 (Steps 1);
val (ptp as (pt,p), tacis) = get_calc 1; Test_Tool.show_pt pt;
initContext 1 Ptool.Thy_ ([1], Frm);
checkContext 1 ([1], Frm) "thy_isac_Test-thm-radd_left_commute";

autoCalculate 1 (Steps 1);
val (ptp as (pt,p), tacis) = get_calc 1; Test_Tool.show_pt pt;
initContext 1 Ptool.Thy_ ([1], Res);
checkContext 1 ([1], Res) "thy_isac_Test-rls-Test_simplify";

"----------- fun guh2theID ------------------------------";
"----------- fun guh2theID ------------------------------";
"----------- fun guh2theID ------------------------------";
val guh = "thy_scri_ListG-thm-zip_Nil";
(*default_print_depth 3; 999*)
take_fromto 1 4 (Symbol.explode guh);
take_fromto 5 9 (Symbol.explode guh);
val rest = takerest (9,(Symbol.explode guh)); 

separate "-" rest;
space_implode "-" rest;
commas rest;

val delim = "-";
val thyID = takewhile [] (not o (curry op= delim)) rest;
val rest' = dropuntil (curry op= delim) rest;
val setc = take_fromto 1 5 rest';
val xstr = takerest (5, rest');

if Thy_Present.guh2theID guh = ["IsacScripts", "ListG", "Theorems", "zip_Nil"] then ()
else error "rewtools.sml: guh2theID thy_scri_ListG-thm-zip_Nil changed";


"----------- debugging on Tests/solve_linear_as_rootpbl -";
"----------- debugging on Tests/solve_linear_as_rootpbl -";
"----------- debugging on Tests/solve_linear_as_rootpbl -";
"----- initContext -----";
reset_states ();
CalcTree 
    [(["equality (1+-1*2+x=(0::real))", "solveFor x", "solutions L"],
      ("Test",
       ["LINEAR", "univariate", "equation", "test"],
       ["Test", "solve_linear"]))];
Iterator 1; moveActiveRoot 1;
autoCalculate 1 CompleteCalcHead;

autoCalculate 1 (Steps 1); val (ptp as (pt,p), tacis) = get_calc 1; Test_Tool.show_pt pt;
if is_curr_endof_calc pt ([1],Frm) then ()
else error "rewtools.sml is_curr_endof_calc ([1],Frm)";

autoCalculate 1 (Steps 1); val (ptp as (pt,p), tacis) = get_calc 1; Test_Tool.show_pt pt;

if not (is_curr_endof_calc pt ([1],Frm)) then ()
else error "rewtools.sml is_curr_endof_calc ([1],Frm) not";
if is_curr_endof_calc pt ([1],Res) then ()
else error "rewtools.sml is_curr_endof_calc ([1],Res)";

initContext 1 Ptool.Thy_ ([1],Res);

"----- checkContext -----";
reset_states ();
CalcTree 
    [(["equality (1+-1*2+x=(0::real))", "solveFor x", "solutions L"],
      ("Test",
       ["LINEAR", "univariate", "equation", "test"],
       ["Test", "solve_linear"]))];
Iterator 1; moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
interSteps 1 ([1],Res);

val (ptp as (pt,p), tacis) = get_calc 1; Test_Tool.show_pt pt;
checkContext 1 ([1],Res) "thy_isac_Test-rls-Test_simplify";

interSteps 1 ([2],Res);
val (ptp as (pt,p), tacis) = get_calc 1; Test_Tool.show_pt pt;

checkContext 1 ([2,1],Res) "thy_isac_Test-rls-Test_simplify";
checkContext 1 ([2,2],Res) "thy_isac_Test-rls-Test_simplify";

"----------- fun is_contained_in ------------------------";
"----------- fun is_contained_in ------------------------";
"----------- fun is_contained_in ------------------------";
val r1 = Thm ("real_diff_minus",ThmC.numerals_to_Free @{thm real_diff_minus});
if Rule_Set.contains r1 Test_simplify then ()
else error "rewtools.sml Rule_Set.contains Thm";

val r1 = Eval ("Groups.plus_class.plus", eval_binop "#add_");
if Rule_Set.contains r1 Test_simplify then ()
else error "rewtools.sml Rule_Set.contains Eval";

val r1 = Eval ("Groups.minus_class.minus", eval_binop "#add_");
if not (Rule_Set.contains r1 Test_simplify) then ()
else error "rewtools.sml Rule_Set.contains Eval";
