(* RL 10.02
 use"../kbtest/rooteq.sml";
 use"rooteq.sml";
 testexamples for RootEq, equations with fractions

 Compiler.Control.Print.printDepth:=10; (*4 default*)
 Compiler.Control.Print.printDepth:=5; (*4 default*)
*)
"----------- rooteq.sml begin--------";
"--------------(1/sqrt(x)=5)---------------------------------------";
"--------------(4*sqrt(4*x+2)=3*sqrt(2*x+24))----------------------";
"--------------(sqrt(x+1)=5)---------------------------------------";
"--------------(sqrt(x+1)+sqrt(4*x+4)=sqrt(9*x+9))-----------------";
"--------------(3*sqrt(x+3)+sqrt(x+6)=sqrt(4*x+33))----------------";
"--------------(sqrt(x+1)+sqrt(4*x+4)=sqrt(9*x+9))-----------------";
"---------------- root-eq + subpbl: solve_linear ----------";
"---------------- root-eq + subpbl: solve_plain_square ----";
"---------------- root-eq + subpbl: no_met: linear --------";
"---------------- root-eq + subpbl: no_met: square --------";
"---------------- no_met in rootpbl -> linear -------------";
"--------------------------------------------------------";

(*=== inhibit exn ?=============================================================

val t = (Thm.term_of o the o (parse RootEq.thy)) "(sqrt(2+x+3)) is_rootTerm_in  x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.True"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(sqrt(2+x+3)) is_rootTerm_in  x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.True"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(nroot 5 (x+4)) is_rootTerm_in  x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.True"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(sqrt(2+x+3)) is_sqrtTerm_in  x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.True"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(sqrt(25)) is_sqrtTerm_in  x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.False"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "sqrt(1 + x) is_normSqrtTerm_in x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.True"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(3+3*sqrt(x)) is_normSqrtTerm_in x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.True"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(sqrt(x+1)+1) is_normSqrtTerm_in x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.False"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(1 - u/(sqrt(r - u))) is_normSqrtTerm_in u";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.False"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(x*(1+x)/(sqrt(x+1))) is_normSqrtTerm_in x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.True"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(1 - (sqrt(2+x+3)^^^3)) is_normSqrtTerm_in  x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.False"  then error "rooteq.sml: new behaviour:" else ();

val t = (Thm.term_of o the o (parse RootEq.thy)) "(1 + (sqrt(2+x+3)^^^3)) is_normSqrtTerm_in  x";
val SOME(t_, _) = rewrite_set_ RootEq.thy  false RootEq_prls t;
val result = UnparseC.term t_;
if result <>  "HOL.True"  then error "rooteq.sml: new behaviour:" else ();



val result = M_Match.match_pbl ["equality (sqrt(x)=1)", "solveFor x", "solutions L"] 
                (Problem.from_store ["rootX", "univariate", "equation"]); 
case result of M_Match.Matches' _  => ()  | _ => error "rooteq.sml: new behaviour:";

val result = M_Match.match_pbl ["equality (sqrt(25)=1)", "solveFor x", "solutions L"] 
                (Problem.from_store ["rootX", "univariate", "equation"]); 
case result of M_Match.NoMatch' _  => ()  | _ => error "rooteq.sml: new behaviour:";

(*---------rooteq---- 23.8.02 ---------------------*)
"---------(1/sqrt(x)=5)---------------------";
val fmz = ["equality (1/sqrt(x)=5)", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootEq",["univariate", "equation"],["no_met"]);

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"1 / x = 25" -> Subproblem ("RootEq", ["univariate", ...]) *)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"1 = 25 * x" -> Subproblem ("RatEq", ["univariate", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "1 + -25 * x = 0")) then ()
else error "rooteq.sml: diff.behav.poly in (1/sqrt(x)=5)";
(*-> Subproblem ("PolyEq", ["polynomial", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
case f of Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"[x = 1 / 25]")) => ()
	 | _ => error "rooteq.sml: diff.behav. [x = 1 / 25]";
if UnparseC.terms (*WN1104changed*) (Ctree.get_assumptions pt p) = "[0 <= 1 / 25]"
(*WN050916 before correction 'rewrite__set_ called with 'Rule_Set.Empty' for ..:
     [(str2term"25 ~= 0",[])] *)
then writeln "should be True\n\
	     \should be True\n\
	     \should be True\n"
else error "rooteq.sml: diff.behav. with 25 ~= 0";

"---------(sqrt(x+1)=5)---------------------";
val fmz = ["equality (sqrt(x+1)=5)", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootEq",["univariate", "equation"],["no_met"]);
(*val p = e_pos'; 
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*-> Subproblem ("RootEq", ["univariate", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "-24 + x = 0")) then ()
else error "rooteq.sml: diff.behav.poly in sqrt(x+1)=5";
(*-> Subproblem ("PolyEq", ["polynomial", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
case f of Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"[x = 24]")) => ()
	 | _ => error "rooteq.sml: diff.behav. [x = 24]";

"-------------(4*sqrt(4*x+2)=3*sqrt(2*x+24))-----------------";
val fmz = ["equality (4*sqrt(4*x+2)=3*sqrt(2*x+24))", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootEq",["univariate", "equation"],["no_met"]);

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "-184 + 46 * x = 0")) then ()
else error "rooteq.sml: diff.behav.poly in 4*sqrt(4*x+2)=3*sqrt(2*x+24)";
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
case f of Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"[x = 4]")) => ()
	 | _ => error "rooteq.sml: diff.behav. [x = 4]";
if Ctree.get_assumptions pt p = [str2term"0 <= 12 * sqrt 2 * 4"] 
then writeln "should be True\nshould be True\nshould be True\n\
	     \should be True\nshould be True\nshould be True\n"
else error "rooteq.sml: diff.behav. with 0 <= 12 * sqrt 2 * 4";

"--------------(sqrt(x+1)+sqrt(4*x+4)=sqrt(9*x+9))----------------";
val fmz = ["equality (sqrt(x+1)+sqrt(4*x+4)=sqrt(9*x+9))", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootEq",["univariate", "equation"],["no_met"]);

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
(*val nxt = Model_Problem ["sq", "rootX", "univariate", "equation"]) *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*"13 + 13 * x + -2 * sqrt ((4 + 4 * x) * (9 + 9 * x)) = 1 + x"))
val nxt = ("Subproblem",Subproblem ("RootEq",["univariate", "equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = Model_Problem ["sq", "rootX", "univariate", "equation"]) *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*"144 + 288 * x + 144 * x ^^^ 2 = 144 + x ^^^ 2 + 288 * x + 143 * x ^^^ 2"))
val nxt = ("Subproblem",Subproblem ("RootEq",["univariate", "equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "0 = 0")) then ()
else error "rooteq.sml: diff.behav.poly in (sqrt(x+1)+sqrt(4*x+4)=sqr..";
(*-> Subproblem ("PolyEq", ["degree_0", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val asm = Ctree.get_assumptions pt p;
if f = Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"UniversalList")) andalso asm = []
then () else error "rooteq.sml: diff.behav. in UniversalList 1";



"--------------(sqrt(x+1)+sqrt(4*x+4)=sqrt(9*x+9))---------- SUBPBL.2.------";
val fmz = 
    ["equality (13 + 13 * x + -2 * sqrt ((4 + 4 * x) * (9 + 9 * x)) = 1 + x)",
     "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootEq",["sq", "rootX", "univariate", "equation"],
		     ["RootEq", "solve_sq_root_equation"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*"144 + 288 * x + 144 * x ^^^ 2 = 144 + x ^^^ 2 + 288 * x + 143 * x ^^^ 2"))
val nxt = ("Subproblem",Subproblem ("RootEq",["univariate", "equation"])) *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([6],Pbl)val nxt = Specify_Method ["PolyEq", "normalise_poly"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([6,2],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,2,Nundef,"0 = 0"))
val nxt = Subproblem ("PolyEq",["polynomial", "univariate", "equation"]))*)
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "0 = 0")) then ()
else error "rooteq.sml: diff.behav.poly in sqrt(x+1)+sqrt(4*x+4)=sqrt..";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = Specify_Method ["PolyEq", "solve_d0_polyeq_equation"])       *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([6,3,1],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,3,Nundef,"HOL.True"))
val nxt = ("Or_to_List",Or_to_List) : string * tac*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([6,3,2],Res)  val f = (~1,EdUndef,3,Nundef,"UniversalList"))
val nxt = Check_Postcond ["degree_0", "polynomial", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([6,3],Res) val f =(~1,EdUndef,2,Nundef,"UniversalList"))
val nxt = Check_Postcond ["normalise", "polynomial", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "UniversalList")) then ()
else error "rooteq.sml: diff.behav.poly in sqrt(x+1)+sqrt(4*x+4)=sqrt..";
(* val Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, str)) = f;
   *)

(*same error as full expl #######*)

"--------------(sqrt(x+1)+sqrt(4*x+4)=sqrt(9*x+9))---------- OKversion----";
val fmz = ["equality (sqrt(x) = 1)", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootEq",["sq", "rootX", "univariate", "equation"],
		     ["RootEq", "solve_sq_root_equation"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([],Pbl)val nxt = Specify_Method ["RootEq", "solve_sq_root_equation"*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* val p = ([2],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,1,Nundef,"x = 1"))
val nxt = ("Subproblem",Subproblem ("RootEq",["univariate", "equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Specify_Method",Specify_Method ["PolyEq", "normalise_poly"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([3,2],Res)val f = Form' (Test_Out.FormKF (~1,EdUndef,2,Nundef,"-1 + x = 0"))
val nxt = Subproblem ("PolyEq",["polynomial", "univariate", "equation"]))*)
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "-1 + x = 0")) then ()
else error "rooteq.sml: diff.behav.poly in sqrt(x+1)+sqrt(4*x+4)=sqrt..";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = Specify_Method ["PolyEq", "solve_d1_polyeq_equation"])       *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([3,3,2],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,3,Nundef,"x = 1"))
val nxt = ("Or_to_List",Or_to_List) *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([3,3,3],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,3,Nundef,"[x = 1]"))
val nxt = ("Check_elementwise",Check_elementwise "Assumptions")*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([3,3,4],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,3,Nundef,"[x = 1]"))
val nxt = Check_Postcond ["degree_1", "polynomial", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([3,3],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,2,Nundef,"[x = 1]"))
val nxt = Check_Postcond ["normalise", "polynomial", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;

(*val p = ([3],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,1,Nundef,"[x = 1]"))
val nxt = ("Check_elementwise",Check_elementwise "Assumptions")
                               --------------------------------*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([4],Res)  val f = Form' (Test_Out.FormKF (~1,EdUndef,1,Nundef,"[x = 1]"))
val nxt = Check_Postcond ["sq", "rootX", "univariate", "equation"]) *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
if p = ([],Res) andalso f = Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"[x = 1]"))
then () else error "diff.behav. in rooteq.sml: sqrt(x) = 1";


"--------------(sqrt(x+1)+sqrt(4*x+4)=sqrt(9*x+9))---------- SHORTEST.1.----\
\                                                            with same error";
val fmz = ["equality (sqrt x = sqrt x)", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootEq",["sq", "rootX", "univariate", "equation"],
		     ["RootEq", "solve_sq_root_equation"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([],Pbl)val nxt = Specify_Method ["RootEq", "solve_sq_root_equation"*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([1],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,1,Nundef,"x = x"))
val nxt = ("Subproblem",Subproblem ("RootEq",["univariate", "equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([2],Pbl) val nxt = Specify_Method ["PolyEq", "normalise_poly"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([2,2],Res) val f = Form' (Test_Out.FormKF (~1,EdUndef,2,Nundef,"0 = 0"))
val nxt = Subproblem ("PolyEq",["polynomial", "univariate", "equation"]))*)
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "0 = 0")) then ()
else error "rooteq.sml: diff.behav.poly in sqrt(x+1)+sqrt(4*x+4)=sqrt..";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([2,3],Pbl)nxt=Specify_Method ["PolyEq", "solve_d0_polyeq_equation"]*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([2,3,2],Res) val f = (Test_Out.FormKF (~1,EdUndef,3,Nundef,"UniversalList"))
val nxt = Check_Postcond ["degree_0", "polynomial", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([2,3],Res) val f = (Test_Out.FormKF (~1,EdUndef,2,Nundef,"UniversalList"))
val nxt =  Check_Postcond ["normalise", "polynomial", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([2],Res)  val f = (Test_Out.FormKF (~1,EdUndef,1,Nundef,"UniversalList"))
val nxt = Check_elementwise "Assumptions"*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val p = ([3],Res) val f = (Test_Out.FormKF (~1,EdUndef,1,Nundef,"UniversalList"))
val nxt = Check_Postcond ["sq", "rootX", "univariate", "equation"])       *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
if p = ([],Res) andalso f = Form'(Test_Out.FormKF (~1,EdUndef,0,Nundef,"UniversalList"))
then () else error "new behav. in rooteq.sml: sqrt x = sqrt x";


"--------------(3*sqrt(x+3)+sqrt(x+6)=sqrt(4*x+33))----------------";
val fmz = ["equality (3*sqrt(x+3)+sqrt(x+6)=sqrt(4*x+33))", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootEq",["univariate", "equation"],["no_met"]);

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*        "6 + x = 60 + 13 * x + -6 * sqrt ((3 + x) * (33 + 4 * x))")) : mout
val nxt = ("Subproblem",Subproblem ("RootEq",["univariate", "equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = Model_Problem ["sq", "rootX", "univariate", "equation"]) *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*"2916 + x ^^^ 2 + 1296 * x + 143 * x ^^^ 2 = 3564 + 1620 * x + 144 * x ^^^ 2"))
val nxt = ("Subproblem",Subproblem ("RootEq",["univariate", "equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "-648 + -324 * x = 0")) then ()
else error "rooteq.sml: diff.behav.poly in 3*sqrt(x+3)+sqrt(x+6)=sqrt..";
(*-> Subproblem ("PolyEq", ["degree_1", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;                                  
case f of Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"[x = -2]")) => ()
	 | _ => error "rooteq.sml: diff.behav. [x = -2]";

"----------- rooteq.sml end--------";


===== inhibit exn ?===========================================================*)

(*===== copied here from OLDTESTS in case there is a Program ===vvv=============================
val c = [];

"---------------- root-eq + subpbl: solve_linear ----------";
"---------------- root-eq + subpbl: solve_linear ----------";
"---------------- root-eq + subpbl: solve_linear ----------";
val fmz = ["equality (sqrt(9+4*x)=sqrt x + sqrt(5+x))",
	   "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test",["sqroot-test", "univariate", "equation", "test"],
   ["Test", "square_equation1"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"sqrt (9 + 4 * x) = sqrt x + sqrt (5 + x)"
square_equation_left*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"9 + 4 * x = (sqrt x + sqrt (5 + x)) ^^^ 2"
Test_simplify*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"9 + 4 * x = 5 + (2 * x + 2 * sqrt (x ^^^ 2 + 5 * x))"
rearrange_assoc*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"9 + 4 * x = 5 + 2 * x + 2 * sqrt (x ^^^ 2 + 5 * x)"
isolate_root*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"sqrt (x ^^^ 2 + 5 * x) = (5 + 2 * x + -1 * (9 + 4 * x)) / (-1 * 2)"
Test_simplify*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"x ^^^ 2 + 5 * x + -1 * (4 + (x ^^^ 2 + 4 * x)) = 0"*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"-4 + x = 0"
  val nxt =("Subproblem",Subproblem ("Test",["LINEAR", "univariate"...*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt =("Model_Problem",Model_Problem ["LINEAR", "univariate"...*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;

val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt = ("Specify_Theory",Specify_Theory "Test")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*("Specify_Problem",Specify_Problem ["LINEAR", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"x = 0 + -1 * -4", nxt Test_simplify*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"x = 4", nxt Check_Postcond ["LINEAR", "univariate", "equation", "test"]*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"[x = 4]", nxt Check_elementwise "Assumptions"*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"[]", nxt Check_Postcond ["sqroot-test", "univariate", "equation", "test"]*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,res)) = f;
if (snd nxt)=End_Proof' andalso res="[x = 4]" then ()
else error "subp-rooteq.sml: new.behav. in  root-eq + subpbl: solve_linear";



"---------------- root-eq + subpbl: solve_plain_square ----";
"---------------- root-eq + subpbl: solve_plain_square ----";
"---------------- root-eq + subpbl: solve_plain_square ----";
val fmz = ["equality (sqrt(5+x)+sqrt(5-x)=sqrt 18)",
	   "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test",["sqroot-test", "univariate", "equation", "test"],
   ["Test", "square_equation2"]);
val Prog sc = (#scr o MethodC.from_store) ["Test", "square_equation2"];
(writeln o UnparseC.term) sc;

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt = ("Apply_Method",Apply_Method ("Test", "square_equation1"))*)
val (p,_,f,nxt,_,pt) = 

me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"9 + -1 * x ^^^ 2 = 0"
  Subproblem ("Test",["plain_square", "univariate", "equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*Model_Problem ["plain_square", "univariate", "equation"]*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt = ("Specify_Theory",Specify_Theory "Test")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*Apply_Method ("Test", "solve_plain_square")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"9 + -1 * x ^^^ 2 = 0", nxt Rewrite_Set "isolate_bdv"*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"x ^^^ 2 = (0 + -1 * 9) / -1", nxt Rewrite_Set "Test_simplify"*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"x ^^^ 2 = 9", nxt Rewrite ("square_equality"*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"x = sqrt 9 | x = -1 * sqrt 9", nxt Rewrite_Set "tval_rls"*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"x = -3 | x = 3", nxt Or_to_List*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"[x = -3, x = 3]", 
  nxt Check_Postcond ["plain_square", "univariate", "equation", "test"]*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;



(*"[x = -3, x = 3]", nxt Check_elementwise "Assumptions"*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"[]", nxt Check_Postcond ["sqroot-test", "univariate", "equation", "test"]*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,res)) = f;
if (snd nxt)=End_Proof' andalso res="[x = -3, x = 3]" then ()
else error "subp-rooteq.sml: new.behav. in  root-eq + subpbl: solve_plain_square";


writeln (pr_ctree pr_short pt);



val Prog s = (#scr o MethodC.from_store) ["Test", "square_equation"];
atomt s;




"---------------- root-eq + subpbl: no_met: linear ----";
"---------------- root-eq + subpbl: no_met: linear ----";
"---------------- root-eq + subpbl: no_met: linear ----";
val fmz = ["equality (sqrt(9+4*x)=sqrt x + sqrt(5+x))",
	   "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test",["squareroot", "univariate", "equation", "test"],
   ["Test", "square_equation"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*"-4 + x = 0", nxt Subproblem ("Test",["univariate", "equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt =("Model_Problem",Model_Problem ["LINEAR", "univar...*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt = ("Specify_Theory",Specify_Theory "Test")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt = ("Specify_Problem",Specify_Problem ["LINEAR", "univariate", "equ*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*Apply_Method ("Test", "norm_univar_equation")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
if p = ([13],Res) then ()
else error ("subp-rooteq.sml: new.behav. in  \
		 \root-eq + subpbl: solve_linear, p ="^(pos'2str p));
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,res)) = f;
if (snd nxt)=End_Proof' andalso res="[x = 4]" then ()
else error "subp-rooteq.sml: new.behav. in  root-eq + subpbl: solve_plain_square";




"---------------- root-eq + subpbl: no_met: square ----";
"---------------- root-eq + subpbl: no_met: square ----";
"---------------- root-eq + subpbl: no_met: square ----";
val fmz = ["equality (sqrt(5+x)+sqrt(5-x)=sqrt 18)",
	   "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test",["squareroot", "univariate", "equation", "test"],
   ["Test", "square_equation"]);
 val Prog sc = (#scr o MethodC.from_store) ["Test", "square_equation"];
 (writeln o UnparseC.term) sc;

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt = ("Apply_Method",Apply_Method ("Test", "square_equation1"))*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*Subproblem ("Test",["univariate", "equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*Model_Problem ["plain_square", "univariate", "equation"]*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt = ("Specify_Theory",Specify_Theory "Test")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt = ("Check_Postcond",Check_Postcond ["squareroot", "univariate", "equ*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,res)) = f;
if (snd nxt)=End_Proof' andalso res="[x = -3, x = 3]" then ()
else error "subp-rooteq.sml: new.behav. in  root-eq + subpbl: no_met: square";



"---------------- no_met in rootpbl -> linear --------------";
"---------------- no_met in rootpbl -> linear --------------";
"---------------- no_met in rootpbl -> linear --------------";
val fmz = ["equality (1+2*x+3=4*x- 6)",
	   "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test",["univariate", "equation", "test"],
   ["no_met"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
(*val nxt = ("Model_Problem",Model_Problem ["normalise", "univariate", "equati*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Apply_Method",Apply_Method ("Test", "norm_univar_equation"*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Subproblem",Subproblem ("Test",["univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Model_Problem",Model_Problem ["LINEAR", "univariate", "equation"]*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Apply_Method",Apply_Method ("Test", "solve_linear"))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Check_Postcond",Check_Postcond ["LINEAR", "univariate", "equatio*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Check_Postcond",Check_Postcond ["normalise", "univariate", "equa*)
val (p,_,Form' (Test_Out.FormKF (_,_,_,_,f)),nxt,_,_) = 
    me nxt p c pt;
if f="[x = 5]" andalso nxt=("End_Proof'",End_Proof') then ()
else error "subp-rooteq.sml: new.behav. in no_met in rootpbl -> linear ---";


Refine.refine fmz ["univariate", "equation", "test"];
M_Match.match_pbl fmz (Problem.from_store ["polynomial", "univariate", "equation", "test"]);

===== copied here from OLDTESTS in case there is a Program ===^^^=============================*)
